unofficial mirror of notmuch@notmuchmail.org
 help / color / mirror / code / Atom feed
From: David Bremner <david@tethera.net>
To: "Rollins, Jameson" <jrollins@caltech.edu>,
	David Bremner <david@tethera.net>,
	"Jorge P. de Morais Neto" <jorge+list@disroot.org>,
	"notmuch@notmuchmail.org" <notmuch@notmuchmail.org>
Subject: [PATCH 1/3] test: add known broken tests for from: and subject:
Date: Wed, 21 Aug 2019 08:41:24 -0300	[thread overview]
Message-ID: <20190821114126.23540-2-david@tethera.net> (raw)
In-Reply-To: <20190821114126.23540-1-david@tethera.net>

Given we want 'a b' to parse as 'a AND b', then for any
probabilistic (free text) prefix foo:, we should also get 'foo:a
foo:b' expanding to 'foo:a AND foo:b'. Currently this is not true due
to the implimentation of regex fields.
---
 test/T760-implicit-operators.sh | 28 ++++++++++++++++++++++++++++
 1 file changed, 28 insertions(+)
 create mode 100755 test/T760-implicit-operators.sh

diff --git a/test/T760-implicit-operators.sh b/test/T760-implicit-operators.sh
new file mode 100755
index 00000000..b79673df
--- /dev/null
+++ b/test/T760-implicit-operators.sh
@@ -0,0 +1,28 @@
+#!/usr/bin/env bash
+test_description='implicit operators in query parser'
+. $(dirname "$0")/test-lib.sh || exit 1
+
+test_AND() {
+    add_message  "[$1]=a@b"
+    add_message  "[$1]=b@c"
+
+    test_begin_subtest "$1: implicitly joined by AND"
+    $2
+    notmuch count $1:a@b > OUTPUT
+    notmuch count $1:a $1:b >> OUTPUT
+    notmuch count $1:a@b OR $1:b@c >> OUTPUT
+    notmuch count $1:a@b $1:b@c >> OUTPUT
+    cat <<EOF > EXPECTED
+1
+1
+2
+0
+EOF
+    test_expect_equal_file EXPECTED OUTPUT
+}
+
+test_AND from test_subtest_known_broken
+test_AND subject test_subtest_known_broken
+test_AND to
+
+test_done
-- 
2.23.0.rc1

  reply	other threads:[~2019-08-21 12:25 UTC|newest]

Thread overview: 10+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2019-08-11 17:20 Apparently, terms with a common prefix are *not* connected by implicit "OR" Jorge P. de Morais Neto
2019-08-11 23:08 ` David Bremner
2019-08-15 14:58   ` Jorge P. de Morais Neto
2019-08-21  1:39     ` David Bremner
2019-08-21  5:48       ` Rollins, Jameson
2019-08-21 11:41         ` WIP: fix implicit operators David Bremner
2019-08-21 11:41           ` David Bremner [this message]
2019-08-25  9:33             ` [PATCH 1/3] test: add known broken tests for from: and subject: Tomi Ollila
2019-08-21 11:41           ` [PATCH 2/3] lib: introduce N_F_GROUP and use it to fix implicit AND for from: David Bremner
2019-08-21 11:41           ` [PATCH 3/3] WIP/test: extend field grouping tests David Bremner

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: https://notmuchmail.org/

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20190821114126.23540-2-david@tethera.net \
    --to=david@tethera.net \
    --cc=jorge+list@disroot.org \
    --cc=jrollins@caltech.edu \
    --cc=notmuch@notmuchmail.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://yhetil.org/notmuch.git/

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).